program ishido;

{$M 16384,0,655360}

uses crt,graph,intuit,dos,drivers,hiscore,timer;

const header='o      U J A s  I s h i d o     o     V. 1.000      o      TP6      o';
      dx=32; dy=32; ox=16; oy=32; xmax=10; ymax=10;
      imafile='ishido.ima';
      ima2fil='ishido2.ima';
      hscfile='ishido.hsc';

type feld=array[0..succ(xmax),0..succ(ymax)] of integer;
     chip=record
             id,vg,hg,pat:integer;
          end;
     chips=array[0..63] of chip;
     liste=array[0..99] of integer;

var ok,ende,fini,aus,kann      :boolean;
    ch                         :char;
    i,j,k,mx,my,g,key,code1,code2:integer;
    ima                        :array[0..63] of Image;
    ima2                       :image;
    igad                       :array[0.. 7] of Gadget;
    xy1,xy2                    :koords;
    ibord1,ibord2              :Border;
    itext1,itext2              :array[0.. 7] of IntuiText;
    f                          :feld;
    stein                      :chips;
    l                          :liste;
    temp,lname                 :string;
    ho,mi,se,tic,se1           :word;
    hsc                        :highscore;
    punkte                     :longint;


{ ---------------------------------------------------------------------- }
procedure getimages;
var i,j,k,anz:integer;
    fh   :file;
begin
assign(fh,imafile);
reset(fh,1);
BlockRead(fh,ima[0],sizeof(Image),anz);
with ima[0] do begin
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   BlockRead(fh,p_data^,anz,anz);
   putimage(dx,dy,p_data^,normalput);
   FreeMem(p_data,anz);
end;
close(fh);

assign(fh,ima2fil);
reset(fh,1);
BlockRead(fh,ima2,sizeof(Image),anz);
with ima2 do begin
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   BlockRead(fh,p_data^,anz,anz);
end;
close(fh);

k:=1;
for j:=1 to 12 do for i:=1 to 4 do begin
   with ima[k] do begin
      x:=0; y:=0; width:=dx; height:=dy; p_nextimage:=nil;
      anz:=imagesize(1,1,width,height);
      GetMem(p_data,anz);
      getimage(i*dx,j*dy,i*dx+pred(width),j*dy+pred(height),p_data^);
   end;
   inc(k);
end;
with ima[k] do begin
   x:=0; y:=0; width:=dx; height:=dy; p_nextimage:=nil;
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   getimage(5*dx,dy,5*dx+pred(width),dy+pred(height),p_data^);
end;
with ima[0] do begin
   x:=0; y:=0; width:=dx; height:=dy; p_nextimage:=nil;
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   getimage(5*dx,2*dy,5*dx+pred(width),2*dy+pred(height),p_data^);
end;
end;

{ --- }

procedure intuikram;
var i,j,k:integer;
begin
for i:=1 to 2 do with itext1[i] do begin
   x:=24;
   y:=4;
   fpen:=1;
   bpen:=13;
   p_nexttext:=addr(itext2[i]);
   if i=1 then itext:=' Neu' else itext:='Quit';
end;
itext2:=itext1;
for i:=1 to 2 do with itext2[i] do begin
   fpen:=0;
   x:=itext1[i].x-1;
   p_nexttext:=nil;
end;
xy1[0]:=0; xy1[1]:=14; xy1[2]:=0;  xy1[3]:=0;  xy1[4]:=79; xy1[5]:=0;
xy2[0]:=0; xy2[1]:=15; xy2[2]:=79; xy2[3]:=15; xy2[4]:=79; xy2[5]:=1;

with ibord1 do begin
   x:=0;
   y:=0;
   fpen:=1;
   bpen:=13;
   drmode:=jam1;
   ecken:=3;
   p_ecken:=addr(xy1);
   p_nextborder:=addr(ibord2);
end;
with ibord2 do begin
   x:=0;
   y:=0;
   fpen:=0;
   bpen:=13;
   drmode:=jam1;
   ecken:=3;
   p_ecken:=addr(xy2);
   p_nextborder:=nil;
end;

for i:=1 to 2 do with igad[i] do begin
   id:=i;
   x:=392+i*80;
   y:=456;
   width:=80;
   height:=16;
   bpen:=13;
   hibpen:=bpen;
   p_loborder:=addr(ibord1);
   p_hiborder:=p_loborder;
   p_loimage:=nil;
   p_hiimage:=p_loimage;
   p_lointuitext:=addr(itext1[i]);
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=nil;
   p_nextgadget:=addr(igad[succ(i)]);
end;

with igad[3] do begin
   id:=3;
   x:=ox+dx;
   y:=oy+dy;
   width:=xmax*dx;
   height:=ymax*dy;
   bpen:=-1;
   hibpen:=bpen;
   p_loborder:=nil;
   p_hiborder:=p_loborder;
   p_loimage:=nil;
   p_hiimage:=p_loimage;
   p_lointuitext:=nil;
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=nil;
   p_nextgadget:=nil;
end;


end;

{ --------------------------------------------------------------------- }
procedure bildschirm(var ok:boolean);
const cc:array[0..15,0..2] of integer=
(( 0,  0,  0), (46, 56, 56), ( 9, 19, 19), (24, 30, 30),
 (31, 15, 13), (63,  9,  0), (56, 35,  3), (63, 56,  5),
 ( 0, 25, 14), ( 0, 39, 18), (14, 24, 30), (28, 37, 49),
 (47, 27, 15), (45, 38, 28), (55, 42, 27), (59, 50, 34));
var i:integer;
var temp:string;
begin
   initscreen(ok);
   if ok then begin
      for i:=0 to 15 do begin
         setpalette(i,0);
         setrgbpalette(i,cc[i,0],cc[i,1],cc[i,2]);
      end;
      getimages;
      intuikram;
   end;
end;


procedure zeichnescreen;
begin
      rectfill(0,0,639,479,2);
      rectfill(8,8,635,23,0);
      rectfill(4,4,631,19,13);
      setcolor(1);
      line(4,4,4,18);
      line(4,4,631,4);
      setcolor(4);
      line(4,19,631,19);
      line(631,5,631,18);
      rectfill(8,460,635,475,0);
      rectfill(4,456,631,471,13);
      setcolor(1);
      line(4,456,4,470);
      line(4,456,631,456);
      setcolor(4);
      line(4,471,631,471);
      line(631,457,631,471);
      setcolor(1);
      outtextxy(38,8,header);
      setcolor(0);
      outtextxy(36,8,header);
      rectfill(484,72,563,87,0);
      rectfill(480,68,559,83,13);
      setcolor(1);
      line(480,68,559,68);
      line(480,68,480,82);
      setcolor(4);
      line(480,83,559,83);
      line(559,69,559,83);
      temp:='Anzeige:';
      setcolor(1);
      outtextxy(489,72,temp);
      setcolor(0);
      outtextxy(488,72,temp);

      rectfill(444,272,607,287,0);
      rectfill(440,268,603,283,13);
      setcolor(1);
      line(440,268,603,268);
      line(440,268,440,282);
      setcolor(4);
      line(440,283,603,283);
      line(603,269,603,283);
      temp:=' Punkte:';
      setcolor(1);
      outtextxy(449,272,temp);
      setcolor(0);
      outtextxy(448,272,temp);
      rectfill(ox+dx+4,oy+dy+4,ox+succ(xmax)*dx+3,oy+succ(ymax)*dy+3,0);
      RefreshGadgets(addr(igad[1]));
end;

{ ----------------------------------------------------------------------- }

procedure aufblenden;
var i:integer;
begin
   for i:=0 to 15 do setpalette(i,i);
end;

procedure abblenden;
var i:integer;
begin
   for i:=15 downto 0 do setpalette(i,0);
end;

procedure showpunkte(p:longint);
var temp:string;
begin
   str(p:6,temp);
   rectfill(520,272,587,281,13);
   setcolor(1);
   outtextxy(521,272,temp);
   setcolor(0);
   outtextxy(520,272,temp);
end;


procedure messi(temp1,temp2:string);
begin
   rectfill(400,320,623,359,4);
   setcolor(0);
   outtextxy(412,332,temp1);
   outtextxy(412,344,temp2);
   setcolor(15);
   outtextxy(408,328,temp1);
   outtextxy(408,340,temp2);
end;


{ ----------------------------------------------------------------------- }
procedure chipszuordnen(var c:chips);
var i,j,k,e:integer;
begin
   e:=0;
   { 24 verschiedene Steine }
   for k:=1 to 3 do if k<>2 then
   for i:=1 to 3 do for j:=1 to 4 do begin
      inc(e);
      with c[e] do begin
         vg:=j;
         hg:=i;
         pat:=k;
      end;
   end;
   for i:=1 to e do with c[i] do id:=pred(pat)*12+4*pred(hg)+vg;
   { der Joker }
   with c[e+1] do begin
      vg:=0;
      hg:=0;
      pat:=0;
      id:=49;
   end;
end;


procedure zeichnestein(x,y,z:integer);
var e:integer;
begin
   if z=0 then Drawimage(x*dx+ox,y*dy+oy,addr(ima[0])) else begin
      e:=stein[z].id;
      Drawimage(x*dx+ox,y*dy+oy,addr(ima[e]));
   end;
end;

procedure shownext(m:integer);
const x=408; y=oy+2*dy;
var i,j,k:integer;
    temp:string;
begin
   k:=m;
   rectfill(x+dx,y+dy,x+6*dx,y+dy+16,4);
   for i:=1 to 5 do begin
      if k>0 then begin
         j:=stein[l[k]].id;
         Drawimage(x+i*dx,y,addr(ima[j]));
         str(k:2,temp);
      end else begin
         DrawImage(x+i*dx,y,addr(ima[0]));
         temp:='  '
      end;
      setcolor(0);  outtextxy(x+i*dx+12,y+dy+8,temp);
      setcolor(15); outtextxy(x+i*dx+8,y+dy+4,temp);
      dec(k);
   end;
end;

procedure setzen(flag:boolean; x,y:integer; var k,pp:integer; var ok:boolean);
var ok2:boolean;
    nachbar:chip;
    i,j:integer;
begin
   ok:=f[x,y]=0;
   pp:=2;
   if ok then with stein[l[k]] do begin
      if (f[x,pred(y)]>0) then begin
         nachbar:=stein[f[x,pred(y)]];
         if pat=0 then j:=2 else j:=0;
         if nachbar.pat=0 then j:=2;
         if nachbar.pat=pat then inc(j);
         if nachbar.vg=vg then inc(j);
         if nachbar.hg=hg then inc(j);
         ok:=ok and (j>1);
         if ok then pp:=pp+pp;
      end;
      if (f[x,succ(y)]>0) then begin
         nachbar:=stein[f[x,succ(y)]];
         if pat=0 then j:=2 else j:=0;
         if nachbar.pat=0 then j:=2;
         if nachbar.pat=pat then inc(j);
         if nachbar.vg=vg then inc(j);
         if nachbar.hg=hg then inc(j);
         ok:=ok and (j>1);
         if ok then pp:=pp+pp;
      end;
      if (f[pred(x),y]>0) then begin
         nachbar:=stein[f[pred(x),y]];
         if pat=0 then j:=2 else j:=0;
         if nachbar.pat=0 then j:=2;
         if nachbar.pat=pat then inc(j);
         if nachbar.vg=vg then inc(j);
         if nachbar.hg=hg then inc(j);
         ok:=ok and (j>1);
         if ok then pp:=pp+pp;
      end;
      if (f[succ(x),y]>0) then begin
         nachbar:=stein[f[succ(x),y]];
         if pat=0 then j:=2 else j:=0;
         if nachbar.pat=0 then j:=2;
         if nachbar.pat=pat then inc(j);
         if nachbar.vg=vg then inc(j);
         if nachbar.hg=hg then inc(j);
         ok:=ok and (j>1);
         if ok then pp:=pp+pp;
      end;
   end;
   if flag then ok:=ok and (pp>2);
   if ok then begin f[x,y]:=l[k]; dec(k); end else pp:=0;
end;


procedure mischen(var l:liste);
const max=78;
var i,j,k,m:integer;
begin
   for i:=1 to 24 do for j:=0 to 2 do l[i+24*j]:=i;
   for i:=max-5 to max do l[i]:=25;
   l[0]:=max;
   for k:=1 to 10 do for i:=1 to max do begin
      j:=succ(random(1000) mod max);
      k:=l[i];
      l[i]:=l[j];
      l[j]:=k
   end;
end;


procedure preloop;
var i,j,k,pp:integer;
    ok      :boolean;
begin
   abblenden;
   zeichnescreen;
   randomize;
   for i:=0 to succ(xmax) do for j:=0 to succ(ymax) do f[i,j]:=0;
   mischen(l);
   punkte:=0;
   for k:=1 to 6 do begin
      repeat
         i:=2+(random(xmax-2));
         j:=2+(random(ymax-2));
         setzen(false,i,j,l[0],pp,ok);
         punkte:=punkte+pp;
      until ok;
   end;
   for i:=1 to xmax do for j:=1 to ymax do zeichnestein(i,j,f[i,j]);
   shownext(l[0]);
   showpunkte(punkte);
   messi('... auf geht''s!','');
   aufblenden;
   fini:=false;
   aus:=false;
end;

procedure finale;
begin
rectfill(0,oy+dy,639,479-dy,2);
putimage(32,48,ima2.p_data^,normalput);
putimage(340,88,ima2.p_data^,normalput);
putimage(164,140,ima2.p_data^,normalput);
delay1(500);
updathighscore(punkte,hscfile,hsc,360,304,12,13,1,0,4);
delay1(500);
end;

{ -------------------------------------------------------------------- }
procedure holeevent(var key,g,mx,my,keycode1,keycode2:integer);
{ kombinierte Maus-Tastaturabfrage mit Keys }
var k,kx,ky:integer;
    temp:string;   tim:longint;
begin
   showmouse;
   keycode1:=-1;
   keycode2:=-1;
   key:=0;
   g:=0;
   repeat
      delay1(50);
      maustastelos(key,mx,my);
      if key>0 then g:=checkgadget(addr(igad[1]),mx,my);
   until (g>0) or keypressed;

   if keypressed then begin
      keycode1:=ord(readkey);
      if keycode1=0 then keycode2:=ord(readkey);
   end;
   hidemouse;
end;

{ -------------------------------------------------------------------- }

begin
chipszuordnen(stein);
loadhighscore(hscfile,hsc);

bildschirm(ok);
if ok then begin
preloop;
repeat
   kann:=false;
   for i:=1 to xmax do for j:=1 to ymax do if f[i,j]=0 then begin
      setzen(true,i,j,l[0],k,ok);
      if ok then begin
         kann:=true;
         f[i,j]:=0;
         inc(l[0]);
      end;
   end;
   if not (kann or fini) then messi('der nchste Stein','pat nicht mehr aufs Brett');


   holeevent(key,g,mx,my,code1,code2);
   if key=0 then case code1 of
   27,81,113: g:=2;
   65,97:     g:=1;
   78,110:    g:=1;
   end;
   case g of
   1: preloop;
   2: ende:=true;
   3: begin
         i:=(mx-ox) div dx;
         j:=(my-oy) div dy;
         setzen(true,i,j,l[0],k,ok);
         if not ok then begin
            messi('Der Stein','pat nicht an diese Stelle');
         end else begin
            zeichnestein(i,j,f[i,j]);
            shownext(l[0]);
            punkte:=punkte+k;
            showpunkte(punkte);
            fini:=l[0]=0;
            if fini then begin
               messi('Gratuliere,','   ... alles geschafft!');
               finale;
            end else messi('','');
         end;
      end;
   end;
until ende;

end;
textmode(3);
end.
